Index: src/language/stats/oneway.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/oneway.q,v
retrieving revision 1.16
diff -u -p -r1.16 oneway.q
--- src/language/stats/oneway.q	5 Dec 2006 15:10:21 -0000	1.16
+++ src/language/stats/oneway.q	10 Dec 2006 03:30:36 -0000
@@ -435,7 +435,8 @@ show_descriptives(void)
 	  gs = gs_array[count];
 
 	  tab_text (t, 1, row + count, 
-		    TAB_LEFT | TAT_TITLE ,value_to_string(&gs->id,indep_var));
+		    TAB_LEFT | TAT_TITLE, var_get_value_name(indep_var,
+                                                             &gs->id));
 
 	  /* Now fill in the numbers ... */
 
@@ -621,7 +622,7 @@ show_contrast_coeffs (short *bad_contras
       group_value = group_values[count];
 
       tab_text (t, count + 2, 1, TAB_CENTER | TAT_TITLE, 
-		value_to_string(group_value, indep_var));
+		var_get_value_name (indep_var, group_value));
 
       for (i = 0 ; i < cmd.sbc_contrast ; ++i ) 
 	{
@@ -917,7 +918,7 @@ run_oneway(const struct ccase *first, co
       if ( casefilter_variable_missing (filter, &c, indep_var))
 	continue;
 
-      indep_val = case_data (&c, indep_var->fv);
+      indep_val = case_data (&c, indep_var);
 	  
       hsh_insert ( global_group_hash, (void *) indep_val );
 
@@ -925,7 +926,7 @@ run_oneway(const struct ccase *first, co
 	{
 	  const struct variable *v = vars[i];
 
-	  const union value *val = case_data (&c, v->fv);
+	  const union value *val = case_data (&c, v);
 
           struct group_proc *gp = group_proc_get (vars[i]);
 	  struct hsh_table *group_hash = gp->group_hash;
Index: src/language/stats/rank.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/rank.q,v
retrieving revision 1.20
diff -u -p -r1.20 rank.q
--- src/language/stats/rank.q	5 Dec 2006 15:10:21 -0000	1.20
+++ src/language/stats/rank.q	10 Dec 2006 03:30:37 -0000
@@ -24,6 +24,8 @@ Foundation, Inc., 51 Franklin Street, Fi
 #include "sort-criteria.h"
 
 #include <data/dictionary.h>
+#include <data/format.h>
+#include <data/missing-values.h>
 #include <data/procedure.h>
 #include <data/variable.h>
 #include <data/case.h>
@@ -247,13 +249,13 @@ rank_cmd (struct dataset *ds, const stru
   for (i = 0; i < n_splits ; i++) 
     {
       struct variable *v = dict_get_split_vars (dataset_dict (ds))[i];
-      criteria.crits[i].fv = v->fv;
+      criteria.crits[i].fv = var_get_case_index (v);
       criteria.crits[i].width = var_get_width (v);
       criteria.crits[i].dir = SRT_ASCEND;
     }
   for (i = 0; i < n_group_vars; i++) 
     {
-      criteria.crits[i + n_splits].fv = group_vars[i]->fv;
+      criteria.crits[i + n_splits].fv = var_get_case_index (group_vars[i]);
       criteria.crits[i + n_splits].width = var_get_width (group_vars[i]);
       criteria.crits[i + n_splits].dir = SRT_ASCEND;
     }
@@ -273,7 +275,7 @@ rank_cmd (struct dataset *ds, const stru
       /* Sort CF into SORTED_CF. */
       reader = casefile_get_destructive_reader (cf) ;
       criteria.crits[criteria.crit_cnt - 1] = sc->crits[i];
-      assert ( sc->crits[i].fv == src_vars[i]->fv );
+      assert ( sc->crits[i].fv == var_get_case_index (src_vars[i]) );
       sorted_cf = sort_execute (reader, &criteria);
       casefile_destroy (cf);
 
@@ -519,7 +521,7 @@ rank_cases (struct casereader *cr,
       if (!casereader_read_xfer (cr, &this_case))
         break;
       
-      this_value = case_data (&this_case, fv);
+      this_value = case_data_idx (&this_case, fv);
       c = dict_get_case_weight (dict, &this_case, &warn);
               
       lookahead = casereader_clone (cr);
@@ -527,7 +529,7 @@ rank_cases (struct casereader *cr,
       while (casereader_cnum (lookahead) < end
              && casereader_read_xfer (lookahead, &lookahead_case))
         {
-          const union value *lookahead_value = case_data (&lookahead_case, fv);
+          const union value *lookahead_value = case_data_idx (&lookahead_case, fv);
           int diff = compare_values (this_value, lookahead_value, width);
 
           if (diff != 0) 
@@ -553,12 +555,12 @@ rank_cases (struct casereader *cr,
         {
           for (i = 0; i < n_rank_specs; ++i) 
             {
-              const int dest_idx = rs[i].destvars[dest_var_index]->fv;
+              const struct variable *dst_var = rs[i].destvars[dest_var_index];
 
 	      if  ( value_is_missing (mv, this_value) )
-		case_data_rw (&this_case, dest_idx)->f = SYSMIS;
+		case_data_rw (&this_case, dst_var)->f = SYSMIS;
 	      else
-		case_data_rw (&this_case, dest_idx)->f = 
+		case_data_rw (&this_case, dst_var)->f = 
 		  rank_func[rs[i].rfunc](c, cc, cc_1, iter, w);
             }
           casefile_append_xfer (dest, &this_case); 
@@ -582,8 +584,8 @@ same_group (const struct ccase *a, const
   for (i = 0; i < crit->crit_cnt - 1; i++)
     {
       struct sort_criterion *c = &crit->crits[i];
-      if (compare_values (case_data (a, c->fv), case_data (b, c->fv),
-                          c->width) != 0)
+      if (compare_values (case_data_idx (a, c->fv),
+                          case_data_idx (b, c->fv), c->width) != 0)
         return false;
     }
 
@@ -612,7 +614,7 @@ rank_sorted_casefile (struct casefile *c
       struct ccase this_case;
       const union value *this_value ;
       double w = 0.0;
-      this_value = case_data( &group_case, ultimate_crit->fv);
+      this_value = case_data_idx( &group_case, ultimate_crit->fv);
 
       if ( !value_is_missing(mv, this_value) )
 	w = dict_get_case_weight (dict, &group_case, &warn);
@@ -620,7 +622,7 @@ rank_sorted_casefile (struct casefile *c
       while (casereader_read (lookahead, &this_case)) 
         {
 	  const union value *this_value = 
-	    case_data(&this_case, ultimate_crit->fv);
+	    case_data_idx(&this_case, ultimate_crit->fv);
           double c = dict_get_case_weight (dict, &this_case, &warn);
           if (!same_group (&group_case, &this_case, crit)) 
             {
@@ -661,7 +663,7 @@ create_resort_key (void *key_var_, struc
 {
   struct variable *key_var = key_var_;
 
-  case_data_rw(cc, key_var->fv)->f = case_num;
+  case_data_rw(cc, key_var)->f = case_num;
   
   return TRNS_CONTINUE;
 }
@@ -907,7 +909,7 @@ cmd_rank (struct lexer *lexer, struct da
   {
     struct sort_criteria criteria;
     struct sort_criterion restore_criterion ;
-    restore_criterion.fv = order->fv;
+    restore_criterion.fv = var_get_case_index (order);
     restore_criterion.width = 0;
     restore_criterion.dir = SRT_ASCEND;
 
Index: src/language/stats/regression.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/regression.q,v
retrieving revision 1.40
diff -u -p -r1.40 regression.q
--- src/language/stats/regression.q	7 Dec 2006 05:16:33 -0000	1.40
+++ src/language/stats/regression.q	10 Dec 2006 03:30:38 -0000
@@ -239,7 +239,7 @@ reg_stats_coeff (pspp_linreg_cache * c)
 	   */
 
 	  val = pspp_coeff_get_value (c->coeff[j], v);
-	  val_s = value_to_string (val, v);
+	  val_s = var_get_value_name (v, val);
 	  strncat (tmp, val_s, MAX_STRING);
 	}
 
@@ -566,12 +566,12 @@ regression_trns_pred_proc (void *t_, str
   n_vals = (*model->get_vars) (model, vars);
 
   vals = xnmalloc (n_vals, sizeof (*vals));
-  output = case_data_rw (c, model->pred->fv);
+  output = case_data_rw (c, model->pred);
   assert (output != NULL);
 
   for (i = 0; i < n_vals; i++)
     {
-      vals[i] = case_data (c, vars[i]->fv);
+      vals[i] = case_data (c, vars[i]);
     }
   output->f = (*model->predict) ((const struct variable **) vars,
 				 vals, model, n_vals);
@@ -606,14 +606,14 @@ regression_trns_resid_proc (void *t_, st
   n_vals = (*model->get_vars) (model, vars);
 
   vals = xnmalloc (n_vals, sizeof (*vals));
-  output = case_data_rw (c, model->resid->fv);
+  output = case_data_rw (c, model->resid);
   assert (output != NULL);
 
   for (i = 0; i < n_vals; i++)
     {
-      vals[i] = case_data (c, vars[i]->fv);
+      vals[i] = case_data (c, vars[i]);
     }
-  obs = case_data (c, model->depvar->fv);
+  obs = case_data (c, model->depvar);
   output->f = (*model->residual) ((const struct variable **) vars,
 				  vals, obs, model, n_vals);
   free (vals);
@@ -734,20 +734,16 @@ static void
 reg_print_categorical_encoding (FILE * fp, pspp_linreg_cache * c)
 {
   int i;
-  size_t j;
   int n_vars = 0;
   struct variable **varlist;
-  struct pspp_coeff *coeff;
-  const struct variable *v;
-  union value *val;
 
   fprintf (fp, "%s", reg_export_categorical_encode_1);
 
   varlist = xnmalloc (c->n_indeps, sizeof (*varlist));
   for (i = 1; i < c->n_indeps; i++)	/* c->coeff[0] is the intercept. */
     {
-      coeff = c->coeff[i];
-      v = pspp_coeff_get_var (coeff, 0);
+      struct pspp_coeff *coeff = c->coeff[i];
+      const struct variable *v = pspp_coeff_get_var (coeff, 0);
       if (var_is_alpha (v))
 	{
 	  if (!reg_inserted (v, varlist, n_vars))
@@ -770,20 +766,22 @@ reg_print_categorical_encoding (FILE * f
 
   for (i = 0; i < n_vars; i++)
     {
-      coeff = c->coeff[i];
+      size_t n_categories = cat_get_n_categories (varlist[i]);
+      size_t j;
+      
       fprintf (fp, "%s.name = \"%s\";\n\t",
                var_get_name (varlist[i]),
 	       var_get_name (varlist[i]));
       fprintf (fp, "%s.n_vals = %d;\n\t",
                var_get_name (varlist[i]),
-	       varlist[i]->obs_vals->n_categories);
+               n_categories);
 
-      for (j = 0; j < varlist[i]->obs_vals->n_categories; j++)
+      for (j = 0; j < n_categories; j++)
 	{
-	  val = cat_subscript_to_value ((const size_t) j, varlist[i]);
+          union value *val = cat_subscript_to_value (j, varlist[i]);
 	  fprintf (fp, "%s.values[%d] = \"%s\";\n\t",
                    var_get_name (varlist[i]), j,
-		   value_to_string (val, varlist[i]));
+		   var_get_value_name (varlist[i], val));
 	}
     }
   fprintf (fp, "%s", reg_export_categorical_encode_2);
@@ -959,14 +957,7 @@ cmd_regression (struct lexer *lexer, str
 static bool
 is_depvar (size_t k, const struct variable *v)
 {
-  /*
-     compare_var_names returns 0 if the variable
-     names match.
-   */
-  if (!compare_var_names (v, v_variables[k], NULL))
-    return true;
-
-  return false;
+  return v == v_variables[k];
 }
 
 /*
@@ -986,7 +977,7 @@ mark_missing_cases (const struct casefil
     {
       row = casereader_cnum (r) - 1;
 
-      val = case_data (&c, v->fv);
+      val = case_data (&c, v);
       cat_value_update (v, val);
       if (var_is_value_missing (v, val))
 	{
@@ -1199,7 +1190,7 @@ run_regression (const struct ccase *firs
 						   current case.
 						 */
 		{
-		  val = case_data (&c, v_variables[i]->fv);
+		  val = case_data (&c, v_variables[i]);
 		  /*
 		     Independent/dependent variable separation. The
 		     'variables' subcommand specifies a varlist which contains
@@ -1222,7 +1213,7 @@ run_regression (const struct ccase *firs
 			}
 		    }
 		}
-	      val = case_data (&c, cmd.v_dependent[k]->fv);
+	      val = case_data (&c, cmd.v_dependent[k]);
 	      gsl_vector_set (Y, row, val->f);
 	      row++;
 	    }
Index: src/language/stats/sort-criteria.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/sort-criteria.c,v
retrieving revision 1.5
diff -u -p -r1.5 sort-criteria.c
--- src/language/stats/sort-criteria.c	5 Dec 2006 15:10:21 -0000	1.5
+++ src/language/stats/sort-criteria.c	10 Dec 2006 03:30:38 -0000
@@ -115,7 +115,7 @@ sort_parse_criteria (struct lexer *lexer
       for (; prev_var_cnt < criteria->crit_cnt; prev_var_cnt++) 
         {
           struct sort_criterion *c = &criteria->crits[prev_var_cnt];
-          c->fv = (*vars)[prev_var_cnt]->fv;
+          c->fv = var_get_case_index ((*vars)[prev_var_cnt]);
           c->width = var_get_width ((*vars)[prev_var_cnt]);
           c->dir = direction;
         }
Index: src/language/stats/t-test.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/t-test.q,v
retrieving revision 1.16
diff -u -p -r1.16 t-test.q
--- src/language/stats/t-test.q	5 Dec 2006 15:10:21 -0000	1.16
+++ src/language/stats/t-test.q	10 Dec 2006 03:30:39 -0000
@@ -154,7 +154,7 @@ struct pair 
 
 static struct pair *pairs=0;
 
-static int parse_value (struct lexer *lexer, union value * v, int type) ;
+static int parse_value (struct lexer *lexer, union value * v, enum var_type);
 
 /* Structures and Functions for the Statistics Summary Box */
 struct ssbox;
@@ -309,7 +309,8 @@ cmd_t_test (struct lexer *lexer, struct 
 	  struct hsh_table *hash;
 	  struct variable *v;
 
-	  hash = hsh_create (n_pairs, compare_var_names, hash_var_name, 0, 0);
+	  hash = hsh_create (n_pairs, compare_vars_by_name, hash_var_by_name,
+          0, 0);
 
 	  for (i=0; i < n_pairs; ++i)
 	    {
@@ -565,9 +566,9 @@ tts_custom_pairs (struct lexer *lexer, s
 /* Parses the current token (numeric or string, depending on type)
     value v and returns success. */
 static int
-parse_value (struct lexer *lexer, union value * v, int type )
+parse_value (struct lexer *lexer, union value * v, enum var_type type)
 {
-  if (type == NUMERIC)
+  if (type == VAR_NUMERIC)
     {
       if (!lex_force_num (lexer))
 	return 0;
@@ -716,16 +717,16 @@ ssbox_independent_samples_populate(struc
 {
   int i;
 
-  char *val_lab0=0;
-  char *val_lab1=0;
+  const char *val_lab0;
+  const char *val_lab1;
   double indep_value[2];
 
   char prefix[2][3]={"",""};
 
   if ( var_is_numeric (indep_var) ) 
     {
-      val_lab0 = val_labs_find( indep_var->val_labs,gp.v.g_value[0]); 
-      val_lab1 = val_labs_find( indep_var->val_labs,gp.v.g_value[1]);
+      val_lab0 = var_lookup_value_label (indep_var, &gp.v.g_value[0]); 
+      val_lab1 = var_lookup_value_label (indep_var, &gp.v.g_value[1]);
     }
   else
     {
@@ -1435,7 +1436,7 @@ common_calc (const struct dictionary *di
       if (! casefilter_variable_missing (filter, c, v) )
 	{
 	  struct group_statistics *gs;
-	  const union value *val = case_data (c, v->fv);
+	  const union value *val = case_data (c, v);
 	  gs = &group_proc_get (cmd->v_variables[i])->ugs;
 
 	  gs->n += weight;
@@ -1507,7 +1508,7 @@ one_sample_calc (const struct dictionary
     {
       struct group_statistics *gs;
       struct variable *v = cmd->v_variables[i];
-      const union value *val = case_data (c, v->fv);
+      const union value *val = case_data (c, v);
 
       gs= &group_proc_get (cmd->v_variables[i])->ugs;
 
@@ -1582,8 +1583,8 @@ paired_calc (const struct dictionary *di
       struct variable *v0 = pairs[i].v[0];
       struct variable *v1 = pairs[i].v[1];
 
-      const union value *val0 = case_data (c, v0->fv);
-      const union value *val1 = case_data (c, v1->fv);
+      const union value *val0 = case_data (c, v0);
+      const union value *val1 = case_data (c, v1);
 
       if (  ! casefilter_variable_missing (filter, c, v0) && 
 	    ! casefilter_variable_missing (filter, c, v1) )
@@ -1708,12 +1709,12 @@ group_calc (const struct dictionary *dic
   if ( casefilter_variable_missing (filter, c, indep_var))
     return 0;
 
-  gv = case_data (c, indep_var->fv);
+  gv = case_data (c, indep_var);
 
   for(i=0; i< cmd->n_variables ; ++i) 
     {
       struct variable *var = cmd->v_variables[i];
-      const union value *val = case_data (c, var->fv);
+      const union value *val = case_data (c, var);
       struct hsh_table *grp_hash = group_proc_get (var)->group_hash;
       struct group_statistics *gs;
 
Index: src/language/tests/casefile-test.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/tests/casefile-test.c,v
retrieving revision 1.9
diff -u -p -r1.9 casefile-test.c
--- src/language/tests/casefile-test.c	11 Nov 2006 23:10:00 -0000	1.9
+++ src/language/tests/casefile-test.c	10 Dec 2006 03:30:39 -0000
@@ -160,8 +160,8 @@ test_casefile (int pattern, size_t value
             fail_test ("Premature end of casefile.");
           for (j = 0; j < value_cnt; j++) 
             {
-              double a = case_num (&read_case, j);
-              double b = case_num (&expected_case, j);
+              double a = case_num_idx (&read_case, j);
+              double b = case_num_idx (&expected_case, j);
               if (a != b)
                 fail_test ("Case %lu fails comparison.", (unsigned long) i); 
             }
@@ -180,7 +180,7 @@ get_random_case (struct ccase *c, size_t
   int i;
   case_create (c, value_cnt);
   for (i = 0; i < value_cnt; i++)
-    case_data_rw (c, i)->f = case_idx % 257 + i;
+    case_data_rw_idx (c, i)->f = case_idx % 257 + i;
 }
 
 static void
@@ -205,8 +205,8 @@ read_and_verify_random_case (struct case
     fail_test ("Premature end of casefile.");
   for (i = 0; i < value_cnt; i++) 
     {
-      double a = case_num (&read_case, i);
-      double b = case_num (&expected_case, i);
+      double a = case_num_idx (&read_case, i);
+      double b = case_num_idx (&expected_case, i);
       if (a != b)
         fail_test ("Case %lu fails comparison.", (unsigned long) case_idx); 
     }
Index: src/language/utilities/set.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/utilities/set.q,v
retrieving revision 1.23
diff -u -p -r1.23 set.q
--- src/language/utilities/set.q	5 Dec 2006 15:10:21 -0000	1.23
+++ src/language/utilities/set.q	10 Dec 2006 03:30:40 -0000
@@ -30,6 +30,7 @@
 #include <data/format.h>
 #include <data/procedure.h>
 #include <data/settings.h>
+#include <data/value.h>
 #include <data/variable.h>
 #include <language/command.h>
 #include <language/lexer/format-parser.h>
Index: src/language/xforms/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/ChangeLog,v
retrieving revision 1.7
diff -u -p -r1.7 ChangeLog
--- src/language/xforms/ChangeLog	1 Dec 2006 06:51:08 -0000	1.7
+++ src/language/xforms/ChangeLog	10 Dec 2006 03:30:40 -0000
@@ -1,3 +1,8 @@
+Sat Dec  9 18:48:20 2006  Ben Pfaff  <blp@gnu.org>
+
+	* compute.c (struct compute_trns): Remove `fv' member, which was
+	redundant with `variable'.
+
 Thu Nov 30 22:46:50 2006  Ben Pfaff  <blp@gnu.org>
 
 	* compute.c: Fix bug #17422, which reports that a variable created
Index: src/language/xforms/compute.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/compute.c,v
retrieving revision 1.12
diff -u -p -r1.12 compute.c
--- src/language/xforms/compute.c	5 Dec 2006 15:10:21 -0000	1.12
+++ src/language/xforms/compute.c	10 Dec 2006 03:30:40 -0000
@@ -26,6 +26,7 @@
 #include <data/procedure.h>
 #include <data/transformations.h>
 #include <data/variable.h>
+#include <data/vector.h>
 #include <language/command.h>
 #include <language/expressions/public.h>
 #include <language/lexer/lexer.h>
@@ -58,7 +59,6 @@ struct compute_trns
 
     /* Variable lvalue, if variable != NULL. */
     struct variable *variable;   /* Destination variable, if any. */
-    int fv;			 /* `value' index of destination variable. */
     int width;			 /* Lvalue string width; 0=numeric. */
 
     /* Vector lvalue, if vector != NULL. */
@@ -120,8 +120,8 @@ compute_num (void *compute_, struct ccas
 
   if (compute->test == NULL
       || expr_evaluate_num (compute->test, c, case_num) == 1.0) 
-    case_data_rw (c, compute->fv)->f = expr_evaluate_num (compute->rvalue, c,
-                                                          case_num); 
+    case_data_rw (c, compute->variable)->f
+      = expr_evaluate_num (compute->rvalue, c, case_num); 
   
   return TRNS_CONTINUE;
 }
@@ -141,18 +141,20 @@ compute_num_vec (void *compute_, struct 
 
       index = expr_evaluate_num (compute->element, c, case_num);
       rindx = floor (index + EPSILON);
-      if (index == SYSMIS || rindx < 1 || rindx > compute->vector->cnt)
+      if (index == SYSMIS
+          || rindx < 1 || rindx > vector_get_var_cnt (compute->vector))
         {
           if (index == SYSMIS)
-            msg (SW, _("When executing COMPUTE: SYSMIS is not a valid value as "
-                       "an index into vector %s."), compute->vector->name);
+            msg (SW, _("When executing COMPUTE: SYSMIS is not a valid value "
+                       "as an index into vector %s."),
+                 vector_get_name (compute->vector));
           else
             msg (SW, _("When executing COMPUTE: %g is not a valid value as "
                        "an index into vector %s."),
-                 index, compute->vector->name);
+                 index, vector_get_name (compute->vector));
           return TRNS_CONTINUE;
         }
-      case_data_rw (c, compute->vector->var[rindx - 1]->fv)->f
+      case_data_rw (c, vector_get_var (compute->vector, rindx - 1))->f
         = expr_evaluate_num (compute->rvalue, c, case_num);
     }
   
@@ -168,7 +170,7 @@ compute_str (void *compute_, struct ccas
   if (compute->test == NULL
       || expr_evaluate_num (compute->test, c, case_num) == 1.0) 
     expr_evaluate_str (compute->rvalue, c, case_num,
-                       case_data_rw (c, compute->fv)->s, compute->width);
+                       case_data_rw (c, compute->variable)->s, compute->width);
   
   return TRNS_CONTINUE;
 }
@@ -193,20 +195,21 @@ compute_str_vec (void *compute_, struct 
         {
           msg (SW, _("When executing COMPUTE: SYSMIS is not a valid "
                      "value as an index into vector %s."),
-               compute->vector->name);
+               vector_get_name (compute->vector));
           return TRNS_CONTINUE; 
         }
-      else if (rindx < 1 || rindx > compute->vector->cnt)
+      else if (rindx < 1 || rindx > vector_get_var_cnt (compute->vector))
         {
           msg (SW, _("When executing COMPUTE: %g is not a valid value as "
                      "an index into vector %s."),
-               index, compute->vector->name);
+               index, vector_get_name (compute->vector));
           return TRNS_CONTINUE;
         }
 
-      vr = compute->vector->var[rindx - 1];
+      vr = vector_get_var (compute->vector, rindx - 1);
       expr_evaluate_str (compute->rvalue, c, case_num,
-                         case_data_rw (c, vr->fv)->s, var_get_width (vr));
+                         case_data_rw (c, vr)->s,
+                         var_get_width (vr));
     }
   
   return TRNS_CONTINUE;
@@ -257,7 +260,7 @@ cmd_if (struct lexer *lexer, struct data
 static trns_proc_func *
 get_proc_func (const struct lvalue *lvalue) 
 {
-  bool is_numeric = lvalue_get_type (lvalue) == NUMERIC;
+  bool is_numeric = lvalue_get_type (lvalue) == VAR_NUMERIC;
   bool is_vector = lvalue_is_vector (lvalue);
 
   return (is_numeric
@@ -271,7 +274,7 @@ static struct expression *
 parse_rvalue (struct lexer *lexer, 
 	      const struct lvalue *lvalue, struct dataset *ds)
 {
-  bool is_numeric = lvalue_get_type (lvalue) == NUMERIC;
+  bool is_numeric = lvalue_get_type (lvalue) == VAR_NUMERIC;
 
   return expr_parse (lexer, ds, is_numeric ? EXPR_NUMBER : EXPR_STRING);
 }
@@ -380,7 +383,7 @@ lvalue_get_type (const struct lvalue *lv
 {
   return (lvalue->variable != NULL
           ? var_get_type (lvalue->variable)
-          : var_get_type (lvalue->vector->var[0]));
+          : vector_get_type (lvalue->vector));
 }
 
 /* Returns true if LVALUE has a vector as its target. */
@@ -400,12 +403,11 @@ lvalue_finalize (struct lvalue *lvalue, 
   if (lvalue->vector == NULL)
     {
       compute->variable = lvalue->variable;
-      compute->fv = compute->variable->fv;
       compute->width = var_get_width (compute->variable);
 
       /* Goofy behavior, but compatible: Turn off LEAVE. */
-      if (dict_class_from_id (var_get_name (compute->variable)) != DC_SCRATCH)
-        compute->variable->leave = false;
+      if (!var_must_leave (compute->variable))
+        var_set_leave (compute->variable, false);
 
       /* Prevent lvalue_destroy from deleting variable. */
       lvalue->is_new_variable = false;
Index: src/language/xforms/count.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/count.c,v
retrieving revision 1.12
diff -u -p -r1.12 count.c
--- src/language/xforms/count.c	5 Dec 2006 15:10:21 -0000	1.12
+++ src/language/xforms/count.c	10 Dec 2006 03:30:40 -0000
@@ -277,7 +277,7 @@ count_numeric (struct criteria *crit, st
 
   for (i = 0; i < crit->var_cnt; i++)
     {
-      double x = case_num (c, crit->vars[i]->fv);
+      double x = case_num (c, crit->vars[i]);
       if (x == SYSMIS)
         counter += crit->count_system_missing;
       else if (crit->count_user_missing
@@ -311,7 +311,7 @@ count_string (struct criteria *crit, str
     {
       char **v;
       for (v = crit->values.str; v < crit->values.str + crit->value_cnt; v++)
-        if (!memcmp (case_str (c, crit->vars[i]->fv), *v,
+        if (!memcmp (case_str (c, crit->vars[i]), *v,
                      var_get_width (crit->vars[i])))
           {
 	    counter++;
@@ -341,7 +341,7 @@ count_trns_proc (void *trns_, struct cca
 	  counter += count_numeric (crit, c);
 	else
 	  counter += count_string (crit, c);
-      case_data_rw (c, dv->var->fv)->f = counter;
+      case_data_rw (c, dv->var)->f = counter;
     }
   return TRNS_CONTINUE;
 }
Index: src/language/xforms/recode.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/recode.c,v
retrieving revision 1.15
diff -u -p -r1.15 recode.c
--- src/language/xforms/recode.c	5 Dec 2006 15:10:21 -0000	1.15
+++ src/language/xforms/recode.c	10 Dec 2006 03:30:41 -0000
@@ -157,7 +157,7 @@ cmd_recode (struct lexer *lexer, struct 
 
       /* Ensure that all the output strings are at least as wide
          as the widest destination variable. */
-      if (trns->dst_type == ALPHA)
+      if (trns->dst_type == VAR_STRING)
         enlarge_dst_widths (trns);
 
       /* Create destination variables, if needed.
@@ -243,7 +243,7 @@ parse_mappings (struct lexer *lexer, str
 
           if (!parse_map_out (lexer, trns->pool, &out))
             return false;
-          dst_type = out.width == 0 ? NUMERIC : ALPHA;
+          dst_type = var_type_from_width (out.width);
           if (have_dst_type && dst_type != trns->dst_type)
             {
               msg (SE, _("Inconsistent target variable types.  "
@@ -262,9 +262,9 @@ parse_mappings (struct lexer *lexer, str
           set_map_in_generic (&in, MAP_CONVERT);
           add_mapping (trns, &map_allocated, &in);
               
-          dst_type = NUMERIC;
-          if (trns->src_type != ALPHA
-              || (have_dst_type && trns->dst_type != NUMERIC)) 
+          dst_type = VAR_NUMERIC;
+          if (trns->src_type != VAR_STRING
+              || (have_dst_type && trns->dst_type != VAR_NUMERIC)) 
             {
               msg (SE, _("CONVERT requires string input values and "
                          "numeric output values."));
@@ -293,7 +293,7 @@ parse_map_in (struct lexer *lexer, struc
 {
   if (lex_match_id (lexer, "ELSE"))
     set_map_in_generic (in, MAP_ELSE);
-  else if (src_type == NUMERIC)
+  else if (src_type == VAR_NUMERIC)
     {
       if (lex_match_id (lexer, "MISSING"))
         set_map_in_generic (in, MAP_MISSING);
@@ -446,7 +446,7 @@ parse_dst_vars (struct lexer *lexer, str
         {
           struct variable *v;
           v = trns->dst_vars[i] = dict_lookup_var (dict, trns->dst_names[i]);
-          if (v == NULL && trns->dst_type == ALPHA) 
+          if (v == NULL && trns->dst_type == VAR_STRING) 
             {
               msg (SE, _("There is no variable named "
                          "%s.  (All string variables specified "
@@ -465,8 +465,8 @@ parse_dst_vars (struct lexer *lexer, str
         {
           msg (SE, _("INTO is required with %s input values "
                      "and %s output values."),
-               var_type_adj (trns->src_type),
-               var_type_adj (trns->dst_type));
+               trns->src_type == VAR_NUMERIC ? _("numeric") : _("string"),
+               trns->dst_type == VAR_NUMERIC ? _("numeric") : _("string"));
           return false;
         }
     }
@@ -478,7 +478,7 @@ parse_dst_vars (struct lexer *lexer, str
         {
           msg (SE, _("Type mismatch.  Cannot store %s data in "
                      "%s variable %s."),
-               trns->dst_type == ALPHA ? _("string") : _("numeric"),
+               trns->dst_type == VAR_STRING ? _("string") : _("numeric"),
                var_is_alpha (v) ? _("string") : _("numeric"),
                var_get_name (v));
           return false;
@@ -628,17 +628,17 @@ recode_trns_proc (void *trns_, struct cc
       struct variable *src_var = trns->src_vars[i];
       struct variable *dst_var = trns->dst_vars[i];
 
-      const union value *src_data = case_data (c, src_var->fv);
-      union value *dst_data = case_data_rw (c, dst_var->fv);
+      const union value *src_data = case_data (c, src_var);
+      union value *dst_data = case_data_rw (c, dst_var);
 
       const struct map_out *out;
 
-      if (trns->src_type == NUMERIC) 
+      if (trns->src_type == VAR_NUMERIC) 
           out = find_src_numeric (trns, src_data->f, src_var);
       else
           out = find_src_string (trns, src_data->s, var_get_width (src_var));
 
-      if (trns->dst_type == NUMERIC) 
+      if (trns->dst_type == VAR_NUMERIC) 
         {
           if (out != NULL)
             dst_data->f = !out->copy_input ? out->value.f : src_data->f; 
Index: src/libpspp/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/ChangeLog,v
retrieving revision 1.44
diff -u -p -r1.44 ChangeLog
--- src/libpspp/ChangeLog	8 Dec 2006 22:24:08 -0000	1.44
+++ src/libpspp/ChangeLog	10 Dec 2006 03:30:41 -0000
@@ -1,3 +1,7 @@
+Sat Dec  9 18:48:55 2006  Ben Pfaff  <blp@gnu.org>
+
+	* misc.h (macro range): Removed, as it was unused.
+
 Sat Dec  9 07:19:01 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* array.c: Removed gratuitous #include
Index: src/libpspp/misc.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/misc.h,v
retrieving revision 1.2
diff -u -p -r1.2 misc.h
--- src/libpspp/misc.h	25 Nov 2006 02:15:01 -0000	1.2
+++ src/libpspp/misc.h	10 Dec 2006 03:30:41 -0000
@@ -43,9 +43,6 @@
 #include <ieeefp.h>		/* Declares finite() under Solaris. */
 #endif
 
-/* Clamps A to be between B and C. */
-#define range(A, B, C) ((A) < (B) ? (B) : ((A) > (C) ? (C) : (A)))
-
 /* Divides nonnegative X by positive Y, rounding up. */
 #define DIV_RND_UP(X, Y) (((X) + ((Y) - 1)) / (Y))
 
Index: src/math/design-matrix.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/design-matrix.c,v
retrieving revision 1.5
diff -u -p -r1.5 design-matrix.c
--- src/math/design-matrix.c	7 Dec 2006 05:16:33 -0000	1.5
+++ src/math/design-matrix.c	10 Dec 2006 03:30:41 -0000
@@ -33,6 +33,7 @@
 #include <libpspp/message.h>
 #include <data/variable.h>
 #include <data/category.h>
+#include <data/value.h>
 
 #include <gsl/gsl_machine.h>
 #include <gsl/gsl_vector.h>
@@ -122,10 +123,10 @@ design_matrix_create (int n_variables,
 	}
       else if (var_is_alpha (v))
 	{
-	  assert (v->obs_vals != NULL);
+          struct cat_vals *obs_vals = var_get_obs_vals (v);
 	  (dm->vars + i)->last_column =
-	    (dm->vars + i)->first_column + v->obs_vals->n_categories - 2;
-	  n_cols += v->obs_vals->n_categories - 1;
+	    (dm->vars + i)->first_column + obs_vals->n_categories - 2;
+	  n_cols += obs_vals->n_categories - 1;
 	}
     }
   dm->m = gsl_matrix_calloc (n_data, n_cols);
